PImage sprite;
PImage bg;
PImage[] kitunsL;
PImage[] kitunsR;

class Kitun {
  float x,y;
  float xs;
  float sacc;
  float spawn;
  int afr;
  int type;
  float chdircool;
  
  float stoptime;

  Kitun() {
    respawn();
  }

  Kitun(float tx, float ty, float txs) {
    x = tx;
    y = ty;
    xs = txs;
    afr = 0;
    sacc = 0;
    spawn = 5.0f;
    type = 0;
  }
  
  void respawn() {
    x = random(32,width-32);
    y = random(300,height-32);
    xs = random(2,4);
    if (random(0,2) < 1) xs*=-1.0f;
    afr = 0;
    sacc = 0;
    spawn = 5.0f;
    type = (int)(random(0,4));
    chdircool = 0;
    stoptime = 0;
  }
  
  
  void update() {
    if (stoptime == 0) {
    x+=xs;
    sacc+=abs(xs);
    if (sacc > 5.0f) {sacc = 0; afr++;}
    if (afr == 3) afr = 0;
    }
    else {
      afr = 1;
    }
    if (spawn > 0) spawn-=0.5f;
    if (chdircool > 0) chdircool-=0.1f;
    if (stoptime > 0) stoptime-=0.1f;
    
    if (stoptime <= 0.0f) stoptime = 0;
    
    if (random(0,10000) > 9990 & stoptime == 0) stoptime = 5;
    
    
    if (x<-32) respawn();
    if (x>width+32) respawn();
    
    if (chdircool == 0) {
    for (int i = 0; i < 60; i++) {
      if ((x>=k[i].x && x < k[i].x+32) && (y > k[i].y && y < k[i].y+32)){
        xs = -xs;
        chdircool = 5;
      }
    }
    }
  }
  
  void draw() {
    tint(255,255);
    if (spawn > 0) tint(255,255-(spawn*(255/5)));
    if (xs<0) image(kitunsR[afr+(type*3)],x,y);
    else image(kitunsL[afr+(type*3)],x,y);
  }
}

Kitun[] k;

void setup() {
  size(640,480);
  frameRate(30);
  sprite = loadImage("../sprite.png");
  bg = loadImage("../bg.png");
  kitunsL = new PImage[12];
  kitunsR = new PImage[12];

  for (int i = 0; i < 12; i++)
  {
    kitunsL[i] = sprite.get(i*32,6*32,32,32);
    kitunsR[i] = sprite.get(i*32,5*32,32,32);
  }
  
  k = new Kitun[60];
  for (int i = 0; i < 60; i++) k[i] = new Kitun();
}

void draw() {
  background(255);
  tint(255,255);
  image(bg,0,0);

  for (int i = 0; i < 60; i++) {
  k[i].update();
  }

  float yl = 480;
  float prevyl = -1;
  int lowest = 0;
  
  int[] drawlist = new int[60];
  
  for (int j = 0; j < 60; j++) {
    for (int i = 0; i < 60; i++) {
      if (k[i].y < yl && k[i].y > prevyl) { yl = k[i].y; lowest = i; }
    }
    drawlist[j] = lowest;
    prevyl = yl;
    yl = 480;
  }

  for (int i = 0; i < 60; i++)
  k[drawlist[i]].draw();
  
  stroke(0);
  fill(0);
  tint(0,255);
  text("*miu* hyvää syntymäpäivää Thihi <3 t: visy",32,32);
}
